%     VIRTUAL FABRIC - программа для получения эффективных свойств текстильных композитов
%     Copyright (C) 2020  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Heat_Transfer_Procedure(Voxel_Model_Directory, Voxel_Model_Name, Analysis_Type, Work_Directory, CPU, DMP, Material_Properties, ...
                                 V_resin_Type, V_resin, Memory, Solver_Command, Solver_Parameters, Mechanical_Element_Type)

global ErrCode;

File_Name = '_Results_Heat_Transfer.txt';

% --- Удаление файла с предыдущими результатами ---

if (exist(File_Name, 'file') == 2)
    delete(File_Name);
end

% Имя файла
Job_Name = 'Virtual_Fabric_Thermal';

% Имя детали
Part_Name = 'FABRIC_RVE';

% --- Чтение воксельной модели ---

fprintf (1, 'Чтение воксельной модели...                             ');

[NODES, ELEMENTS, ORIENTATIONS, RVE_Coordinates, Node_Merge_Tolerance, Fout, V_resin_free] = Process_Voxel_Model(Voxel_Model_Directory, Voxel_Model_Name, Work_Directory, Job_Name, Analysis_Type, Part_Name, Mechanical_Element_Type);

if (ErrCode < 0)
    return;
end

fprintf (1, 'OK!\n');

% --- Вычисление объемных долей ---

fprintf (1, 'Вычисление объемных долей...                            ');

switch V_resin_Type
    
    case 'LOCAL'
        
        V_resin_local = V_resin;
        V_resin_total = (1 - V_resin_free) * V_resin_local + V_resin_free;
        
    case 'GLOBAL'
        
        V_resin_total = V_resin;
        V_resin_local = (V_resin_total - V_resin_free) / (1 - V_resin_free);
    
end

if ((V_resin_local <= 1 - pi()/(2*sqrt(3))) || (V_resin_local >= 1))
    ErrCode = -1;
    fprintf (1, '\nОшибка: недопустимое значение локальной объемной доли связующего!\n');
    fclose(Fout);
    return;
end

fprintf (1, 'OK!\n');

fprintf (1, '\nVm_total = %g    Vm_local = %g    Vm_free = %g\n\n', V_resin_total, V_resin_local, V_resin_free);

% --- Осреднение плотности ---

fprintf (1, 'Осреднение плотности...                                 ');

Density = Density_Homogenization(Material_Properties.Fiber_rho, Material_Properties.Matrix_rho, V_resin_total);

fprintf (1, 'OK!\n');

% --- Осреднение удельной теплоемкости ---

fprintf (1, 'Осреднение удельной теплоемкости...                     ');

Cp = Specific_Heat_Homogenization(Material_Properties.Fiber_Cp, Material_Properties.Matrix_Cp, Material_Properties.Fiber_rho, Material_Properties.Matrix_rho, V_resin_total);

fprintf (1, 'OK!\n');

% --- Вычисление эффективных свойств жгута ---

fprintf (1, 'Вычисление эффективных свойств жгута...\n');

Yarn_Properties = Calculate_Yarn_Properties(V_resin_local, Analysis_Type, Material_Properties, Work_Directory, 'FALSE');

if (ErrCode < 0)
    return;
end

% --- Запись свойств материала ---

fprintf (1, 'Запись свойств материала...                             ');

Write_Materials(Fout, Material_Properties, Yarn_Properties, Analysis_Type, 'ALPHA');

if (ErrCode < 0)
    return;
end

fprintf (1, 'OK!\n');

% --- Запись граничных условий ---

fprintf (1, 'Запись граничных условий...                             ');

Write_BC_Thermal(Fout, NODES, RVE_Coordinates, Node_Merge_Tolerance, Part_Name, Solver_Parameters);

if (ErrCode < 0)
    return;
end

fprintf (1, 'OK!\n');

% Закрытие файла
fclose(Fout);

% --- Удаление старого файла Job_Name.dat ---

if (exist([Work_Directory '\' Job_Name '.dat'], 'file') == 2)
    delete([Work_Directory '\' Job_Name '.dat']);
end

% --- Решение задачи в Abaqus ---

fprintf (1, 'Решение задачи в Abaqus...                              ');

% Команда для запуска решателя
Abaqus_Command = strtrim(Solver_Command);
Abaqus_Command = [Abaqus_Command sprintf(' job=%s', Job_Name)];

if (CPU > 1)
    Abaqus_Command = [Abaqus_Command sprintf(' cpus=%i', CPU)];
end

if (DMP > 1)
    Abaqus_Command = [Abaqus_Command sprintf(' mp_host_split=%i', DMP)];
end

if (~isempty(Memory))
    Abaqus_Command = [Abaqus_Command ' ' strtrim(Memory)];
end

Abaqus_Command = [Abaqus_Command ' ask_delete="OFF" -seq'];

% Смена текущей папки на рабочую папку
Current_Folder = cd(Work_Directory);

% Запуск решателя
[status,cmdout] = system(Abaqus_Command);

if (~isempty(cmdout))
    fprintf(1, '\nПредупреждение! Непустая переменная cmdout после вызова решателя:\n[%s]\n', strtrim(cmdout));
end

% Возврат к старой папке
cd(Current_Folder);

% Проверка status
if (status ~= 0)
    fprintf (1, '\nВыполнение команды [%s]\nзавершилось с ошибкой!\n', Abaqus_Command);
    fprintf (1, '------------------------------------------------------------------------------------\n');
    fprintf (1, '%s\n', cmdout);
    fprintf (1, '------------------------------------------------------------------------------------\n');
    ErrCode = -1;
    return;
end

% Пауза для закрытия всех файлов решателем
pause(3);

fprintf (1, 'OK!\n');

% --- Чтение результатов ---

fprintf (1, 'Чтение результатов...                                   ');

ELEMENTS(size(ELEMENTS,1),12) = 0;
ELEMENTS(:,5:12) = ELEMENTS(:,2:9);
ELEMENTS(:,2) = ones(size(ELEMENTS,1),1) * 3;
ELEMENTS(:,3) = ones(size(ELEMENTS,1),1) * 8;
ELEMENTS(:,4) = zeros(size(ELEMENTS,1),1);

Results_Thermal = Read_Dat_File_Therm(Job_Name, Work_Directory, ELEMENTS, ORIENTATIONS);

if (ErrCode < 0)
    return;
end

fprintf (1, 'OK!\n');

% --- Осреднение теплопроводности ---

fprintf (1, 'Осреднение теплопроводности...                          ');

Lambda = Conductivity_Homogenization(Results_Thermal, RVE_Coordinates);

fprintf (1, 'OK!\n');

% --- Запись результатов ---

fprintf (1, 'Запись эффективных свойств...                           ');

Write_Result_File_Therm(Current_Folder, File_Name, Density, Cp, Lambda);

if (ErrCode < 0)
    return;
end

fprintf (1, 'OK!\n');

% Сообщение об успешном создании файла с результатами
fprintf (1, '\n    Файл [%s] создан успешно!\n', [Current_Folder '\' File_Name]);
